# "about imgv" code by Ryan Kulla, rkulla@gmail.com
import gl
from cursor import normal_cursor
from img_screen import get_center, my_update_screen
from show_message import show_message
from usr_event import check_quit
import pygame.font, pygame.time, pygame.event
from pygame.display import update
from pygame.locals import MOUSEMOTION, MOUSEBUTTONDOWN, KEYDOWN


def command_about(screen, new_img, rect, file, num_imgs):
    normal_cursor()
    about(screen)
    rect = get_center(screen, new_img)
    num_imgs = len(gl.files)
    my_update_screen(new_img, screen, rect, file, num_imgs)


def about(screen):
    font = pygame.font.Font(gl.FONT_NAME, 14)
    loading_msg = "* * * LOADING HELP -- PLEASE WAIT * * *"
    show_message(screen, loading_msg, ((screen.get_width() / 2) - (font.size(loading_msg)[0] / 2), 25, 0, 0), 12, ("bold"))
    msg = ' IMGV 3.1, by Ryan Kulla...' # start with a space for transparency to work right
    msg_font = pygame.font.Font(gl.FONT_NAME, 13)   
    msg_font.set_bold(1)
    char = 0
    i = 0
    pygame.event.set_blocked(MOUSEMOTION)
    transp = 0
    while 1:
        event = pygame.event.poll()
        pygame.time.wait(1)
        check_quit(event)
        if event.type == KEYDOWN or event.type == MOUSEBUTTONDOWN:
            break
        if char < len(msg):
            if msg[char] != ' ': # don't delay on spaces
                pygame.time.delay(100)

            ren = msg_font.render(msg[char], 1, gl.WHITE) # one char at a time
            ren_rect = ren.get_rect()
            # center it
            ren_rect[0] = ren_rect[0] + (i) + (screen.get_width() / 2) - (msg_font.size(msg)[0] / 2)
            ren_rect[1] = 40
            screen.blit(ren, ren_rect)
  
            if transp == 0:
                # draw the transparent 'tinted' background dynamically to print 'msg' on
                transp = 1 # prevents from coloring over itself over and over getting darker and darker
                transren = pygame.Surface((ren_rect[0],ren_rect[1]), 90).convert_alpha()
                transren.fill([gl.MENU_COLOR[0], gl.MENU_COLOR[1], gl.MENU_COLOR[2], 50]) # RGBA (A=Alpha)
                screen.blit(transren, (ren_rect[0], ren_rect[1]))
                transrect = transren.get_rect()
                update(transrect)

            i = i + ren.get_width() # make letters space evenly
            char = char + 1
            update(ren_rect)
        else:
            break
