# imgv.conf configuration code by Ryan Kulla, rkulla@gmail.com
import gl
import os
from error_box import errorbox


def read_config_file():
    f = open(gl.CONF_FILE)
    for line in f.readlines():
        if cfg_match(line, "WRAP"):
            gl.WRAP = chopnl(line)
        if cfg_match(line, "WRAP_SLIDESHOW"):
            gl.WRAP_SLIDESHOW = chopnl(line)
        if cfg_match(line, "PASSWORD"):
            gl.CORRECT_PASSWORD = chopnl(line)
        if cfg_match(line, "KEEP_MENU_OPEN"):
            gl.KEEP_MENU_OPEN = chopnl(line)
        if cfg_match(line, "THUMB_SIZE"):
            gl.THUMB_VAL = chopnl(line)
        if cfg_match(line, "FIT_IMAGE"):
            gl.FIT_IMAGE_VAL = chopnl(line)
        if cfg_match(line, "FIT_IMAGE_SLIDESHOW"):
            gl.FIT_IMAGE_SLIDESHOW_VAL = chopnl(line)
        if cfg_match(line, "START_DIRECTORY"):
            gl.START_DIRECTORY_VAL = chopnl(line)
            try:
                os.chdir(gl.START_DIRECTORY_VAL)
            except:
                pass
        if cfg_match(line, "START_COLOR"):
            color = chopnl(line)
            if color not in gl.COLORS.keys():
                errorbox("Configuration Error", "%s is an invalid color" % color)
            gl.MENU_COLOR = gl.SHOW_MESSAGE_COLOR = gl.COLORS[color]
            if color == "gl.BLACK": 
                gl.FONT_BG = gl.WHITE
                gl.FONT_BG_NEED_CHANGE = 1
        if cfg_match(line, "IMGV_COLOR"):
            color = chopnl(line)
            if color not in gl.COLORS.keys():
                errorbox("Configuration Error", "%s is an invalid color" % color)
            gl.IMGV_COLOR = gl.COLORS[color]
        if cfg_match(line, "TEXT_BGCOLOR"):
            color = chopnl(line)
            if color not in gl.COLORS.keys():
                errorbox("Configuration Error", "%s is an invalid color" % color)
            gl.FONT_BG = gl.COLORS[color]
        if cfg_match(line, "BUTTON_BGCOLOR"):
            color = chopnl(line)
            if color not in gl.COLORS.keys():
                errorbox("Configuration Error", "%s is an invalid color" % color)
            gl.BUTTON_BGCOLOR = gl.COLORS[color]
        if cfg_match(line, "BUTTON_HOVERCOLOR"):
            color = chopnl(line)
            if color not in gl.COLORS.keys():
                errorbox("Configuration Error", "%s is an invalid color" % color)
            gl.BUTTON_HOVERCOLOR = gl.COLORS[color]
        if cfg_match(line, "BUTTON_TEXTCOLOR"):
            color = chopnl(line)
            if color not in gl.COLORS.keys():
                errorbox("Configuration Error", "%s is an invalid color" % color)
            gl.BUTTON_TEXTCOLOR = gl.COLORS[color]
        if cfg_match(line, "BUTTON_TEXTHOVERCOLOR"):
            color = chopnl(line)
            if color not in gl.COLORS.keys():
                errorbox("Configuration Error", "%s is an invalid color" % color)
            gl.BUTTON_TEXTHOVERCOLOR = gl.COLORS[color]
        if cfg_match(line, "CANCEL_BUTTONCOLOR"):
            color = chopnl(line)
            if color not in gl.COLORS.keys():
                errorbox("Configuration Error", "%s is an invalid color" % color)
            gl.CANCEL_BUTTONCOLOR = gl.COLORS[color]
        if cfg_match(line, "MOVIES"):
            gl.MOVIES_VAL = int(chopnl(line))
        if cfg_match(line, "EXTERNAL_VIEWER"):
            gl.EXTERNAL_VIEWER = chopnl(line)
        if cfg_match(line, "WALLPAPER_PROGRAM"):
            gl.WALLPAPER_PROGRAM = chopnl(line)
        if cfg_match(line, "IMGV_RESOLUTION"):
            gl.IMGV_RESOLUTION = chopnl(line)
            try:
                gl.MAX_SCREEN_FILES = gl.MAX_SF[gl.IMGV_RESOLUTION]
            except:
                gl.MAX_SCREEN_FILES = gl.MAX_SF["640x480"]
            gl.IMGV_RESOLUTION = int(gl.IMGV_RESOLUTION.split('x')[0]), int(gl.IMGV_RESOLUTION.split('x')[1])
        if cfg_match(line, "FULLSCREEN"):
            if chopnl(line) == "YES":
                gl.START_FULLSCREEN = 1
            else:
                gl.START_FULLSCREEN = 0
        if cfg_match(line, "TRANSITIONAL_EFFECT"):
            line = chopnl(line)
            if line == "MELT":
                gl.TRANS_FX = "MELT"
            elif line == "VERTICAL_BLINDS":
                gl.TRANS_FX = "VERTICAL_BLINDS"
            elif line == "FADE_IN":
                gl.TRANS_FX = "FADE_IN"
            elif line == "NONE":
                gl.TRANS_FX = "NONE"
            else:
                gl.TRANS_FX = line


def get_conf_name():
    try:
        for file in os.listdir(os.environ['HOME']):
            if file == ".imgv.conf":
                return (os.environ['HOME'] + os.sep + ".imgv.conf")
    except KeyError:
        return (gl.DATA_DIR + "imgv.conf")
    return (gl.DATA_DIR + "imgv.conf")


def cfg_match(line, val):
    if line.find(val + "=") != -1 and line.find("#") == -1:
        return 1
    return 0


def chopnl(line):
    return line.split('=')[1].replace('\n', '')
