# imgv error box code by Ryan Kulla, rkulla@gmail.com
import gl
from img_screen import clean_screen, init_screen
from usr_event import left_click, check_quit
from cursor import normal_cursor
import pygame


def errorbox(title, msg):
    "display a pygame error box"
    clean_screen()
    init_screen()
    errorbox_resolution = 450, 150
    err_screen = pygame.display.set_mode(errorbox_resolution)
    normal_cursor()
    pygame.display.set_caption(title)
    errorbox_color = gl.IMGV_COLOR
    msg_color = gl.WHITE 
    ok_fg_color = gl.SILVER 
    ok_bg_color = gl.BLUE 
    font = pygame.font.Font(gl.FONT_NAME, 12)
    msg_ren = font.render(msg, 1, msg_color)
    err_screen.fill(errorbox_color)
    err_screen.blit(msg_ren, (10, 10))
    ok = font.render('OK', 1, ok_fg_color)
    ok_rect = ok.get_rect().inflate(20, 10)
    ok_rect.centerx = err_screen.get_rect().centerx
    ok_rect.bottom = err_screen.get_rect().bottom - 10
    err_screen.fill(ok_bg_color, ok_rect)
    err_screen.blit(ok, ok_rect.inflate(-20, -10))
    pygame.display.flip()
    while 1:
        event = pygame.event.wait()
        cursor = pygame.mouse.get_pos()
        check_quit(event)
        if left_click(event):
            if ok_rect.collidepoint(cursor):
                clean_screen()
                raise SystemExit

