# image search/filter code by Ryan Kulla, rkulla@gmail.com
import gl
from os.path import basename
from show_message import show_message
from input_box import ask
from usr_event import check_quit, left_click, hit_key
import pygame.event, pygame.font, pygame.display, pygame.mouse
from pygame.locals import MOUSEBUTTONDOWN, MOUSEMOTION, KEYDOWN, K_ESCAPE, K_1, K_2, K_3, K_4, K_5, K_6, K_7, K_8, K_9, K_KP1, K_KP2, K_KP3,\
K_KP4, K_KP5, K_KP6, K_KP7, K_KP8, K_KP9


FIRST_RECT1 = SECOND_RECT1 = THIRD_RECT1 = FOURTH_RECT1 = FIFTH_RECT1 = SIXTH_RECT1 = SEVENTH_RECT1 = EIGHTH_RECT1 = NINTH_RECT1 =\
(-1, -1, -1, -1)


def command_get_filter_info(screen):
    screen.fill(gl.BLACK)
    pygame.display.flip()
    menu_items = []
    font = pygame.font.Font(gl.FONT_NAME, 10)
    font.set_underline(1)
    font.set_bold(1)
    res_font = pygame.font.Font(gl.FONT_NAME, 18)
    res_font.set_bold(1)
    esc = font.render("CLOSE", 1, gl.CANCEL_BUTTONCOLOR)
    esc_rect = esc.get_rect()
    esc_rect[0] = 10
    screen.blit(esc, esc_rect)
    pygame.display.update(esc_rect)
    
    show_message(screen, 'To apply a search filter click as many options below as you need and then click "Done"', (10, 15), 12)
    show_message(screen, 'For example, if you don\'t want to view movies then just click "Do not end with" and input:  .mpg, .mpeg',\
                (10, 45), 12)
    show_message(screen, 'Now when you load a directory the filter will be applied to the filenames it contains.', (10, 75), 12)
    pygame.event.set_blocked(MOUSEMOTION)
    while 1:
        event = pygame.event.poll()
        pygame.time.wait(1)
        check_quit(event)
        if hit_key(event, K_ESCAPE):
            gl.ADDED_DIR_NUMS = 0
            return
        
        show_message(screen, "[Enter an option number or click an option]", "bottom", 13, ("bold"))
        if event.type == KEYDOWN and event.key in (K_1, K_2, K_3, K_4, K_5, K_6, K_7, K_8, K_9, K_KP1, K_KP2, K_KP3, K_KP4,\
                                                   K_KP5, K_KP6, K_KP7, K_KP8, K_KP9):
            if hit_key(event, K_1) or hit_key(event, K_KP1):
                do_startwith(screen)
            if hit_key(event, K_2) or hit_key(event, K_KP2):
                do_donot_startwith(screen)
            if hit_key(event, K_3) or hit_key(event, K_KP3):
                do_endwith(screen)
            if hit_key(event, K_4) or hit_key(event, K_KP4):
                do_donot_endwith(screen)
            if hit_key(event, K_5) or hit_key(event, K_KP5):
                do_contain(screen)
            if hit_key(event, K_6) or hit_key(event, K_KP6):
                do_donot_contain(screen)
            if hit_key(event, K_7) or hit_key(event, K_KP7):
                do_view_filter(screen)
            if hit_key(event, K_8) or hit_key(event, K_KP8):
                do_erase_filter(screen)
            if hit_key(event, K_9) or hit_key(event, K_KP9):
                gl.ADDED_DIR_NUMS = 0
                return
            break
        
        cursor = pygame.mouse.get_pos()

        if left_click(event):
            if esc_rect.collidepoint(cursor):
                gl.ADDED_DIR_NUMS = 0
                return 
        
        hover_fx(screen, menu_items, cursor, font)
        if event.type == MOUSEBUTTONDOWN and pygame.mouse.get_pressed()[0]:
            for it in menu_items:
                if it[0].collidepoint(cursor) and it[1] in filt_ops:
                    if it[1] == "1) Start with":
                        do_startwith(screen)
                    if it[1] == "2) Do not start with":
                        do_donot_startwith(screen)
                    if it[1] == "3) End with":
                        do_endwith(screen)
                    if it[1] == "4) Do not end with":
                        do_donot_endwith(screen)
                    if it[1] == "5) Contain":
                        do_contain(screen)
                    if it[1] == "6) Do not contain":
                        do_donot_contain(screen)
                    if it[1] == "7) View current filter":
                        do_view_filter(screen)
                    if it[1] == "8) Erase current filter":
                        do_erase_filter(screen)
                    if it[1] == "9) Done":
                        gl.ADDED_DIR_NUMS = 0
                        return
                    break
            else:
                continue
            break
        (menu_items, filt_ops) = get_filter_info(screen, menu_items)


def get_filter_info(screen, menu_items):
    filt_ops = ["1) Start with", "2) Do not start with", "3) End with", "4) Do not end with", "5) Contain", "6) Do not contain",\
                "7) View current filter", "8) Erase current filter", "9) Done"]
    line = 95 # start position of menu from top of screen
    for op in filt_ops:
        font = pygame.font.Font(gl.FONT_NAME, 18)
        font.set_bold(1)
        ren = font.render(op, 1, gl.BLUE, gl.FONT_BG)
        ren_rect = ren.get_rect()
        ren_rect[0] = 20
        ren_rect[1] = line
        menu_items.append((ren_rect, op))
        screen.blit(ren, ren_rect)
        line = line + 30
        pygame.display.update(ren_rect)    
    return (menu_items, filt_ops)


def filter_files(file_list):
    # weee, no regex's. Gotta love Python
    new_list = []
    temp_list = []
    if "endwith" in gl.FILTER_COMMAND.keys():
        if new_list == []:
            new_list = file_list
        filt_split = [x.strip() for x in gl.FILTER_COMMAND["endwith"].split(',')] # allow spaces between commas
        if len(filt_split) >= 1:
            for i in filt_split:
                temp_list = temp_list + [x for x in new_list if x.endswith(i)]
            new_list = temp_list
            temp_list = []
    if "notendwith" in gl.FILTER_COMMAND.keys():
        if new_list == []:
            new_list = file_list
        filt_split = [x.strip() for x in gl.FILTER_COMMAND["notendwith"].split(',')]
        if len(filt_split) >= 1:
            for i in filt_split:
                new_list = [x for x in new_list if not x.endswith(i)]
    if "startwith" in gl.FILTER_COMMAND.keys():
        if new_list == []: 
            new_list = file_list
        filt_split = [x.strip() for x in gl.FILTER_COMMAND["startwith"].split(',')]
        if len(filt_split) >= 1:
            for i in filt_split:
                temp_list = temp_list + [x for x in new_list if basename(x).startswith(i)]
            new_list = temp_list
            temp_list = []
    if "notstartwith" in gl.FILTER_COMMAND.keys():
        if new_list == []: 
            new_list = file_list
        filt_split = [x.strip() for x in gl.FILTER_COMMAND["notstartwith"].split(',')]
        if len(filt_split) >= 1:
            for i in filt_split:
                new_list = [x for x in new_list if not basename(x).startswith(i)]
    if "contain" in gl.FILTER_COMMAND.keys():
        if new_list == []:
            new_list = file_list
        filt_split = [x.strip() for x in gl.FILTER_COMMAND["contain"].split(',')]
        if len(filt_split) >= 1:
            for i in filt_split:
                temp_list = temp_list + [x for x in new_list if basename(x).find(i) != -1]
            new_list = temp_list
            temp_list = []
    if "notcontain" in gl.FILTER_COMMAND.keys():
        if new_list == []:
            new_list = file_list
        filt_split = [x.strip() for x in gl.FILTER_COMMAND["notcontain"].split(',')]
        if len(filt_split) >= 1:
            for i in filt_split:
                temp_list = temp_list + [x for x in new_list if basename(x).find(i) == -1]
            new_list = temp_list
            temp_list = []
    if new_list == []:
        new_list = [gl.NO_MATCHES_IMG]
    return new_list


def view_filter(screen):
    screen.fill(gl.BLACK)
    pygame.display.flip()
    show_message(screen, "Current filter", "top", 20, ("underline", "bold"))
    show_message(screen, "Imgv will only display files whose filenames:", (5, 30), 15, ("bold"))
    line = 60
    for k in gl.FILTER_COMMAND.keys():
        font = pygame.font.Font(gl.FONT_NAME, 12)
        if k == "startwith":
            ren = font.render("Start with: %s" % gl.FILTER_COMMAND["startwith"], 1, (255, 255, 255), (0, 0, 0))
        if k == "notstartwith":
            ren = font.render("Do not start with:  %s" % gl.FILTER_COMMAND["notstartwith"], 1, (255, 255, 255), (0, 0, 0))
        if k == "endwith":
            ren = font.render("End with:  %s" % gl.FILTER_COMMAND["endwith"], 1, (255, 255, 255), (0, 0, 0))
        if k == "notendwith":
            ren = font.render("Do not end with:  %s" % gl.FILTER_COMMAND["notendwith"], 1, (255, 255, 255), (0, 0, 0))
        if k == "contain":
            ren = font.render("Contain:  %s" % gl.FILTER_COMMAND["contain"], 1, (255, 255, 255), (0, 0, 0))
        if k == "notcontain":
            ren = font.render("Do not contain:  %s" % gl.FILTER_COMMAND["notcontain"], 1, (255, 255, 255), (0, 0, 0))
        ren_rect = ren.get_rect()
        ren_rect[0] = 5
        ren_rect[1] = line
        screen.blit(ren, ren_rect)
        line = line + 30
        pygame.display.update(ren_rect)
    while 1:
        ev = pygame.event.wait()
        check_quit(ev)
        if ev.type == KEYDOWN or ev.type == MOUSEBUTTONDOWN:
            return


def do_startwith(screen):
    screen.fill(gl.BLACK)
    pygame.display.flip()
    show_message(screen, "Enter the string you want all image names to start with.", (10, 25), 12)
    show_message(screen, 'For example, to view only images that start with the string'
                         ' "red", as in "red_car.jpg", input:  red', (10, 40), 12)
    show_message(screen, 'To input multiple strings separate them with commas.', (10, 65), 12)
    show_message(screen, 'For example, to only load images that start with the strings "red" or '
                         '"blue", input:  red, blue', (10, 80), 12)
    show_message(screen, 'To search for a single image just input its filename:  whatever.jpg', (10, 110), 12)
    startwith_str = ask(screen, "Start with")
    if startwith_str != None:
        gl.FILTER_COMMAND["startwith"] = startwith_str
    command_get_filter_info(screen)


def do_donot_startwith(screen):
    screen.fill(gl.BLACK)
    pygame.display.flip()
    show_message(screen, "Enter the string that you don't want image names to start with.", (10, 25), 12)
    show_message(screen, 'For example, to view all images that do not start with the string'
                         ' "red", input:  red', (10, 40), 12)
    show_message(screen, 'To input multiple strings separate them with commas.', (10, 65), 12)
    show_message(screen, 'For example, to only load images that do not start with the strings "red" or'
                         ' "blue", input:  red, blue', (10, 80), 12)
    notstartwith_str = ask(screen, "Do not start with")
    if notstartwith_str != None:
        gl.FILTER_COMMAND["notstartwith"] = notstartwith_str
    command_get_filter_info(screen)


def do_endwith(screen):
    screen.fill(gl.BLACK)
    pygame.display.flip()
    show_message(screen, "Enter the string you want all image names to end with.", (10, 25), 12)
    show_message(screen, 'For example, to view all images that end with the string'
                         ' ".jpg", as in "car.jpg", input:  .jpg', (10, 40), 12)
    show_message(screen, 'To input multiple strings separate them with commas.', (10, 65), 12)
    show_message(screen, 'For example, to load only jpegs and bitmaps, input:  '
                         '.jpg, .jpeg, .bmp', (10, 80), 12)
    endwith_str = ask(screen, "End with")
    if endwith_str != None:
        gl.FILTER_COMMAND["endwith"] = endwith_str
    command_get_filter_info(screen)


def do_donot_endwith(screen):
    screen.fill(gl.BLACK)
    pygame.display.flip()
    show_message(screen, "Enter the string that you don't want image names to end with.", (10, 25), 12)
    show_message(screen, 'For example, to view all images that do not end with the string'
                         ' ".jpg", as in "car.jpg", input:  .jpg', (10, 40), 12)
    show_message(screen, 'To input multiple strings separate them with commas.', (10, 65), 12)
    show_message(screen, 'For example, to only load images that are not GIFs, input:  '
                         '.gif', (10, 80), 12)
    notendwith_str = ask(screen, "Do not end with")
    if notendwith_str != None:
        gl.FILTER_COMMAND["notendwith"] = notendwith_str
    command_get_filter_info(screen)


def do_contain(screen):
    screen.fill(gl.BLACK)
    pygame.display.flip()
    show_message(screen, "Enter the string you want all image names to contain.", (10, 25), 12)
    show_message(screen, 'For example, to view all images that contain the string'
                         ' "red", as in "my_red_car.jpg", input:  red', (10, 40), 12)
    show_message(screen, 'To input multiple strings separate them with commas.', (10, 65), 12)
    show_message(screen, 'For example, to only load images that contain the strings "red" or'
                         ' "blue", input:  red, blue', (10, 80), 12)
    contain_str = ask(screen, "Contain")
    if contain_str != None:
        gl.FILTER_COMMAND["contain"] = contain_str
    command_get_filter_info(screen)


def do_donot_contain(screen):
    screen.fill(gl.BLACK)
    pygame.display.flip()
    show_message(screen, "Enter the string that you don't want image names to contain.", (10, 25), 12)
    show_message(screen, 'For example, to view only images that do not contain the string'
                         ' "red", as in "my_red_car.jpg", input:  red', (10, 40), 12)
    show_message(screen, 'To input multiple strings separate them with commas.', (10, 65), 12)
    show_message(screen, 'For example, to only load images that do not contain the strings "red" or'
                         ' "blue", input:  red, blue', (10, 80), 12)
    notcontain_str = ask(screen, "Do not contain")
    if notcontain_str != None:
        gl.FILTER_COMMAND["notcontain"] = notcontain_str
    command_get_filter_info(screen)


def do_view_filter(screen):
    view_filter(screen)
    command_get_filter_info(screen)


def do_erase_filter(screen):
    gl.FILTER_COMMAND = {}
    command_get_filter_info(screen)


def hover_fx(screen, menu_items, cursor, font):
    global FIRST_RECT1, SECOND_RECT1, THIRD_RECT1, FOURTH_RECT1, FIFTH_RECT1, SIXTH_RECT1, SEVENTH_RECT1, EIGHTH_RECT1, NINTH_RECT1#
    for it in menu_items:
        if it[0].collidepoint(cursor):
            if it[1] == "1) Start with":
                blank_fx(screen, 1)
                FIRST_RECT1 = (it[0][0] - 10, it[0][1] + (font.size(it[1])[1] / 2), it[0][2], it[0][3])
                show_message(screen, "+", FIRST_RECT1, 12, ("bold"))
                break
            elif it[1] == "2) Do not start with":
                blank_fx(screen, 2)
                SECOND_RECT1 = (it[0][0] - 10, it[0][1] + (font.size(it[1])[1] / 2), it[0][2], it[0][3])
                show_message(screen, "+", SECOND_RECT1, 12, ("bold"))
                break
            elif it[1] == "3) End with":
                blank_fx(screen, 3)
                THIRD_RECT1 = (it[0][0] - 10, it[0][1] + (font.size(it[1])[1] / 2), it[0][2], it[0][3])
                show_message(screen, "+", THIRD_RECT1, 12, ("bold"))
                break
            elif it[1] == "4) Do not end with":
                blank_fx(screen, 4)
                FOURTH_RECT1 = (it[0][0] - 10, it[0][1] + (font.size(it[1])[1] / 2), it[0][2], it[0][3])
                show_message(screen, "+", FOURTH_RECT1, 12, ("bold"))
                break
            elif it[1] == "5) Contain":
                blank_fx(screen, 5)
                FIFTH_RECT1 = (it[0][0] - 10, it[0][1] + (font.size(it[1])[1] / 2), it[0][2], it[0][3])
                show_message(screen, "+", FIFTH_RECT1, 12, ("bold"))
                break
            elif it[1] == "6) Do not contain":
                blank_fx(screen, 6)
                SIXTH_RECT1 = (it[0][0] - 10, it[0][1] + (font.size(it[1])[1] / 2), it[0][2], it[0][3])
                show_message(screen, "+", SIXTH_RECT1, 12, ("bold"))
                break
            elif it[1] == "7) View current filter":
                blank_fx(screen, 7)
                SEVENTH_RECT1 = (it[0][0] - 10, it[0][1] + (font.size(it[1])[1] / 2), it[0][2], it[0][3])
                show_message(screen, "+", SEVENTH_RECT1, 12, ("bold"))
                break
            elif it[1] == "8) Erase current filter":
                blank_fx(screen, 8)
                EIGHTH_RECT1 = (it[0][0] - 10, it[0][1] + (font.size(it[1])[1] / 2), it[0][2], it[0][3])
                show_message(screen, "+", EIGHTH_RECT1, 12, ("bold"))
                break
            elif it[1] == "9) Done":
                blank_fx(screen, 9)
                NINTH_RECT1 = (it[0][0] - 10, it[0][1] + (font.size(it[1])[1] / 2), it[0][2], it[0][3])
                show_message(screen, "+", NINTH_RECT1, 12, ("bold"))
                break


def blank_fx(screen, row):
    if row != 1:
        show_message(screen, "  ", FIRST_RECT1, 12, ("bold"))
    if row != 2:
        show_message(screen, "  ", SECOND_RECT1, 12, ("bold"))
    if row != 3:
        show_message(screen, "  ", THIRD_RECT1, 12, ("bold"))
    if row != 4:
        show_message(screen, "  ", FOURTH_RECT1, 12, ("bold"))
    if row != 5:
        show_message(screen, "  ", FIFTH_RECT1, 12, ("bold"))
    if row != 6:
        show_message(screen, "  ", SIXTH_RECT1, 12, ("bold"))
    if row != 7:
        show_message(screen, "  ", SEVENTH_RECT1, 12, ("bold"))
    if row != 8:
        show_message(screen, "  ", EIGHTH_RECT1, 12, ("bold"))
    if row != 9:
        show_message(screen, "  ", NINTH_RECT1, 12, ("bold"))
