# multiview code by Ryan Kulla, rkulla@gmail.com
import gl
import os
from sys import platform#
from img_screen import get_center, my_update_screen, paint_screen, junk_rect
from slideshow import get_speed, started_msg, stopped_msg, pause
from show_message import show_message
from load_img import load_img
from usr_event import hit_key, left_click, right_click, middle_click, check_quit
from cursor import wait_cursor, normal_cursor
import pygame.event, pygame.mouse, pygame.draw, pygame.transform, pygame.time
from pygame.display import update, set_caption
from pygame.locals import MOUSEMOTION, MOUSEBUTTONDOWN, KEYDOWN, K_ESCAPE, K_SPACE, K_BACKSPACE, K_4,\
K_LALT, K_RALT, K_LCTRL, K_RCTRL, K_p, K_PAUSE, K_w, K_TAB


def command_four(screen, file, new_img):
    gl.MULTI_VIEWING = 1
    paint_screen(screen)
    set_caption(gl.TITLE)
    (file, new_img) = four(screen, file, new_img)
    rect = get_center(screen, new_img)
    num_imgs = len(gl.files)
    my_update_screen(new_img, screen, rect, file, num_imgs)
    pygame.event.set_blocked(MOUSEMOTION)
    gl.MULTI_VIEWING = 0
    return (file, new_img, new_img, new_img, rect)


def four(screen, file, new_img):
    old_file = file
    def_rect = new_img.get_rect()
    (img_one_rect, img_two_rect, img_three_rect, img_four_rect) = (0, 0, 0, 0)
    (img_one_name, img_two_name, img_three_name, img_four_name) = (0, 0, 0, 0)
    (show_img_one, show_img_two, show_img_three, show_img_four) = (0, 0, 0, 0)

    rect = junk_rect()
    (file, img_one_rect, img_one_name, img_one_file) = square_one(screen, file, def_rect)
    (file, img_two_rect, img_two_name, img_two_file) = square_two(screen, file, def_rect)
    (file, img_three_rect, img_three_name, img_three_file) = square_three(screen, file, def_rect)
    (file, img_four_rect, img_four_name, img_four_file) = square_four(screen, file, def_rect)

    pygame.event.set_allowed(MOUSEMOTION)
    while 1:
        flag = 0
        event = pygame.event.wait()
        cursor = pygame.mouse.get_pos()
        if hit_key(event, K_ESCAPE):
            file = old_file
            break
        check_quit(event)
        if hit_key(event, K_SPACE) or hit_key(event, K_4) or right_click(event): # show next 4 images
            paint_screen(screen)
            flag = 1
        if hit_key(event, K_BACKSPACE) or middle_click(event): # show previous 4 images
            paint_screen(screen)
            file = file - 8
            flag = 1
        if flag == 1:
            (file, img_one_rect, img_one_name, img_one_file) = square_one(screen, file, def_rect)
        if flag == 1:
            (file, img_two_rect, img_two_name, img_two_file) = square_two(screen, file, def_rect)
        if flag == 1:
            (file, img_three_rect, img_three_name, img_three_file) = square_three(screen,\
            file, def_rect)
        if flag == 1:
            (file, img_four_rect, img_four_name, img_four_file) = square_four(screen, file,\
            def_rect)
        if gl.TOGGLE_STATUS_BAR:
            (show_img_one, show_img_two, show_img_three, show_img_four, rect) =    hover_square(\
             screen, show_img_one, show_img_two, show_img_three,    show_img_four, img_one_rect,\
            img_two_rect, img_three_rect, img_four_rect, img_one_name, img_two_name, img_three_name,\
            img_four_name, img_one_file, img_two_file, img_three_file, img_four_file, rect)
        if hit_key(event, K_w): 
            if len(gl.files) <= 1: # nothin to slideshow
                file = old_file
                break # kick em out
            (file, img_one_file, img_two_file, img_three_file, img_four_file) =\
            my_fourslideshow(screen, new_img, rect, screen.get_rect().midtop, gl.files[file], file,\
            len(gl.files), img_one_file, img_two_file, img_three_file, img_four_file)
            flag = 1
        if left_click(event):
            if img_one_rect.collidepoint(cursor):
                wait_cursor()
                new_img = load_img(gl.files[img_one_file], screen)
                return (img_one_file, new_img)
            if img_two_rect.collidepoint(cursor):
                wait_cursor()
                new_img = load_img(gl.files[img_two_file], screen)
                return (img_two_file, new_img)
            if img_three_rect.collidepoint(cursor):
                wait_cursor()
                new_img = load_img(gl.files[img_three_file], screen)
                return (img_three_file, new_img)
            if img_four_rect.collidepoint(cursor):
                wait_cursor()
                new_img = load_img(gl.files[img_four_file], screen)
                return (img_four_file, new_img)
    return (file, new_img)


def square_one(screen, file, def_rect):
    wait_cursor()
    draw_lines(screen)
    if file >= len(gl.files) or file <= 0:
        file = 0
    img_one_name = gl.files[file]
    img_one_file = file
    img_one = load_img(img_one_name, screen)
    file = file + 1
    img_one = adjust_img_size(img_one, screen.get_width(), screen.get_height())
    img_one_rect = img_one.get_rect()
    screen.blit(img_one, img_one_rect)
    update(img_one_rect)
    draw_lines(screen)
    normal_cursor()
    return (file, img_one_rect, img_one_name, img_one_file)


def square_two(screen, file, def_rect):
    wait_cursor()
    draw_lines(screen)
    if file >= len(gl.files) or file <= 0:
        file = 0
    img_two_name = gl.files[file]
    img_two_file = file
    img_two = load_img(img_two_name, screen)
    file = file + 1
    img_two = adjust_img_size(img_two, screen.get_width(), screen.get_height())
    img_two_rect = img_two.get_rect()
    img_two_rect[0] = (screen.get_width() / 2)
    screen.blit(img_two, img_two_rect)
    update(img_two_rect)
    draw_lines(screen)
    normal_cursor()
    return (file, img_two_rect, img_two_name, img_two_file)


def square_three(screen, file, def_rect):
    wait_cursor()
    draw_lines(screen)
    if file >= len(gl.files) or file <= 0:
        file = 0
    img_three_name = gl.files[file]
    img_three_file = file
    img_three = load_img(img_three_name, screen)
    file = file + 1
    img_three = adjust_img_size(img_three, screen.get_width(), screen.get_height())
    img_three_rect = img_three.get_rect()
    img_three_rect[1] = (screen.get_height() / 2)
    screen.blit(img_three, img_three_rect)
    update(img_three_rect)
    draw_lines(screen)
    normal_cursor()
    return (file, img_three_rect, img_three_name, img_three_file)


def square_four(screen, file, def_rect):
    wait_cursor()
    draw_lines(screen)
    if file >= len(gl.files) or file <= 0:
        file = 0
    img_four_name = gl.files[file]
    img_four_file = file
    img_four = load_img(img_four_name, screen)
    file = file + 1
    img_four = adjust_img_size(img_four, screen.get_width(), screen.get_height())
    img_four_rect = img_four.get_rect()
    img_four_rect[0] = (screen.get_width() / 2)
    img_four_rect[1] = (screen.get_height() / 2)
    screen.blit(img_four, img_four_rect)
    update(img_four_rect)
    draw_lines(screen)
    normal_cursor()
    return (file, img_four_rect, img_four_name, img_four_file)


def draw_lines(screen):
    "draw the lines that split the screen into 4 squares"
    screen_width = screen.get_width()
    screen_height = screen.get_height()
    line_color = gl.SHOW_MESSAGE_COLOR
    vline = pygame.draw.line(screen, line_color, ((screen_width / 2), screen_height),\
    ((screen_width / 2), 0), 2)
    hline = pygame.draw.line(screen, line_color, (0, (screen_height / 2)), (screen_width,\
    (screen_height / 2)), 2)
    update(vline)
    update(hline)


def hover_square(screen, show_img_one, show_img_two, show_img_three, show_img_four,\
img_one_rect, img_two_rect, img_three_rect, img_four_rect, img_one_name, img_two_name,\
img_three_name, img_four_name, img_one_file, img_two_file, img_three_file, img_four_file, rect):
    "display image name in title bar on mouse over"
    nav_msg = "(Space/Right-click=Next. Backspace/Middle-click=Previous. W=Slideshow)"
    num_imgs = len(gl.files)
    font_size = 9
    cursor = pygame.mouse.get_pos()
    if show_img_one == 0:
        if img_one_rect:
            if img_one_rect.collidepoint(cursor):
                paint_screen(screen, rect)
                name = os.path.basename(img_one_name)
                if len(name) > 30:
                    name = name[:30] + '~'
                if platform == 'win32':
                    set_caption("imgv - %s: %d/%d %s" % (name, img_one_file + 1, num_imgs, nav_msg))
                else:
                    rect = show_message(screen, "%s: %d/%d %s" % (name, img_one_file + 1, num_imgs, nav_msg), "top", font_size, ("bold"))
                show_img_one = 1
                (show_img_two, show_img_three, show_img_four) = (0, 0, 0)
    if show_img_two == 0:
        if img_two_rect:
            if img_two_rect.collidepoint(cursor):
                paint_screen(screen, rect)
                name = os.path.basename(img_two_name)
                if len(name) > 30:
                    name = name[:30] + '~'
                if platform == 'win32':
                    set_caption("imgv - %s: %d/%d %s" % (name, img_two_file + 1, num_imgs, nav_msg))
                else:
                    rect = show_message(screen, "%s: %d/%d %s" % (name, img_two_file + 1, num_imgs, nav_msg), "top", font_size, ("bold"))
                show_img_two = 1
                (show_img_one, show_img_three, show_img_four) = (0, 0, 0)
    if show_img_three == 0:
        if img_three_rect:
            if img_three_rect.collidepoint(cursor):
                paint_screen(screen, rect)
                name = os.path.basename(img_three_name)
                if len(name) > 30:
                    name = name[:30] + '~'
                if platform == 'win32':
                    set_caption("imgv - %s: %d/%d %s" % (name, img_three_file + 1, num_imgs, nav_msg))
                else:
                    rect = show_message(screen, "%s: %d/%d %s" % (name, img_three_file + 1, num_imgs, nav_msg), "top", font_size, ("bold"))
                show_img_three = 1
                (show_img_one, show_img_two, show_img_four) = (0, 0, 0)
    if show_img_four == 0:
        if img_four_rect:
            if img_four_rect.collidepoint(cursor):
                paint_screen(screen, rect)
                name = os.path.basename(img_four_name)
                if len(name) > 30:
                    name = name[:30] + '~'
                if platform == 'win32':
                    set_caption("imgv - %s: %d/%d %s" % (name, img_four_file + 1, num_imgs, nav_msg))
                else:
                    rect = show_message(screen, "%s: %d/%d %s" % (name, img_four_file + 1, num_imgs, nav_msg), "top", font_size, ("bold"))
                show_img_four = 1
                (show_img_one, show_img_two, show_img_three) = (0, 0, 0)
    return (show_img_one, show_img_two, show_img_three, show_img_four, rect)


def adjust_img_size(the_img, screen_width, screen_height):
    "scale the image down if necessary to fit in its square"
    (img_width, img_height) = the_img.get_size()
    small_img = the_img
    if img_width < img_height:
        if img_width > (screen_width / 2) or img_height > (screen_height / 2):
            small_img = pygame.transform.scale(the_img, ((screen_height / 2),\
            (screen_height / 2)))
    if img_width > img_height:
        if img_width > (screen_width / 2) or img_height > (screen_height / 2):
            small_img = pygame.transform.scale(the_img, ((screen_width / 2),\
            (screen_height / 2)))
    if img_width == img_height: # if the demensions are equal
        if img_width > (screen_width / 2) or img_height > (screen_height / 2):
            small_img = pygame.transform.scale(the_img, ((screen_width / 2),\
            (screen_height / 2)))
    return small_img


def my_fourslideshow(screen, new_img, rect, screen_midtop, filename, file, num_imgs,\
img_one_file, img_two_file, img_three_file, img_four_file):
    speed = get_speed(screen, new_img, rect, screen_midtop, filename, file, num_imgs)
    if not speed == -1:  # didn't hit Esc from get_speed:
        started_msg(screen, "Hit any key to start (P=Pause, ESC=Stop)")
        dont_call = 0
        while 1:
            event = pygame.event.poll()
            pygame.time.wait(1)
            pygame.event.set_blocked(MOUSEMOTION)
            check_quit(event)
            if event.type == KEYDOWN and event.key not in (K_LALT, K_RALT, K_LCTRL, K_RCTRL,\
            K_p, K_PAUSE, K_TAB, K_SPACE, K_BACKSPACE) or event.type == MOUSEBUTTONDOWN:
                stopped_msg(screen)
                file = file - 1
                break
            if hit_key(event, K_p) or hit_key(event, K_PAUSE):
                pause(screen)
            if dont_call == 1:
                break
            if gl.WRAP_SLIDESHOW == "0":
                if file < num_imgs:
                    (file, dont_call, img_one_file, img_two_file, img_three_file, img_four_file) =\
                    show_fourslideshow_imgs(screen, file, new_img.get_rect(), speed)
            if gl.WRAP_SLIDESHOW == "1":
                if file >= num_imgs:
                    file = 0
                (file, dont_call, img_one_file, img_two_file, img_three_file, img_four_file) =\
                show_fourslideshow_imgs(screen, file, new_img.get_rect(), speed)
            pygame.time.delay(5) 
    return (file, img_one_file, img_two_file, img_three_file, img_four_file)


def show_fourslideshow_imgs(screen, file, def_rect, speed):
    paint_screen(screen)
    (file, img_one_rect, img_one_name, img_one_file) = square_one(screen, file, def_rect)
    (file, img_two_rect, img_two_name, img_two_file) = square_two(screen, file, def_rect)
    (file, img_three_rect, img_three_name, img_three_file) = square_three(screen, file, def_rect)
    (file, img_four_rect, img_four_name, img_four_file) = square_four(screen, file, def_rect)
    if speed > 0:
        for i in range(speed):
            event = pygame.event.poll()
            pygame.time.wait(1)
            if event.type == KEYDOWN and event.key not in (K_LALT, K_RALT, K_LCTRL, K_RCTRL,\
            K_p, K_PAUSE, K_TAB, K_SPACE, K_BACKSPACE) or event.type == MOUSEBUTTONDOWN:
                stopped_msg(screen)
                return (file, 1, img_one_file, img_two_file, img_three_file, img_four_file)
            if hit_key(event, K_p) or hit_key(event, K_PAUSE):
                pause(screen)
            pygame.time.delay(1000)
    return (file, 0, img_one_file, img_two_file, img_three_file, img_four_file)
    
