# keyboard event code by Ryan Kulla, rkulla@gmail.com
import gl
from os import getcwd, chdir
from os.path import basename
from img_screen import get_center, my_update_screen
from dir_nav import command_show_dirs
from usr_event import hit_key
from list_images import command_img_names
from res import resize_it
from edit import command_edit_menu
from img_surf import command_next_img, command_prev_img, command_last_img, command_first_img
from refresh import command_refresh
from res import command_640x480, command_800x600, command_1024x768, command_1280x1024, command_fullscreen, command_show_res_modes
from open_url import open_url
from pan import command_up, command_down, command_right, command_left
from help import command_help
from verbose import command_verbose_info
from zoom import command_zoom_in, command_zoom_out
from cursor import normal_cursor, wait_cursor
from slideshow import my_slideshow
from four import command_four
from thumb import command_thumbs
from randomizer import command_shuffle, command_unshuffle
from playlist import command_add_to_play_list, command_play_list_options
from hide import command_hide
from rm_img import command_remove_img, command_delete_img
from confirm import get_confirmation
from rotate import command_rotate_left, command_rotate_right, command_horiz, command_vert
from downloader import save_remote_img
from load_img import load_img
from load_timers import start_timer, check_timer
import pygame.key
from pygame.locals import *


def handle_keyboard(event, screen, rect, new_img, img, refresh_img, file, num_imgs,\
screen_midtop, screen_width, screen_height, new_img_width, new_img_height, last_rect):
    if hit_key(event, K_d):
        gl.USING_SCROLL_MENU = 1
        # save current things in case the user ESCAPES out of show_dirs()
        gl.LAST_DIR = getcwd()
        last_files = gl.files
        (last_new_img, last_img, last_refresh_img, last_num_imgs, last_file, last_rect) =\
         (new_img, img, refresh_img, num_imgs, file, rect)
        (new_img, img, refresh_img, num_imgs, file, rect) = command_show_dirs(new_img,\
        img, screen, rect, file, num_imgs)
        # user ESCAPED from show_dirs, reset last values
        if gl.ESCAPED == 1:
            gl.ADDED_DIR_NUMS = 0
            (new_img, img, refresh_img, num_imgs, file, rect) =\
            (last_new_img, last_img, last_refresh_img, last_num_imgs, last_file, last_rect)
            chdir(gl.LAST_DIR)
            gl.files = last_files
            my_update_screen(new_img, screen, rect, file, num_imgs)
        else:
            gl.REFRESH_IMG_COUNT = 0
        gl.ESCAPED = 0
        gl.USING_SCROLL_MENU = 0
    if hit_key(event, K_i):
        (new_img, img, refresh_img, file, rect) = command_img_names(screen, new_img, img, file, num_imgs, rect)
    if event.type == VIDEORESIZE:
        "let user resize window"
        (screen_midtop, rect) = resize_it(event, screen, new_img, file, num_imgs)
    if hit_key(event, K_F1):
        (screen_midtop, rect) = command_640x480(new_img, file, num_imgs, rect)
    if hit_key(event, K_F2):
        (screen_midtop, rect) = command_800x600(new_img, file, num_imgs, rect)
    if hit_key(event, K_F3):
        (screen_midtop, rect) = command_1024x768(new_img, file, num_imgs, rect)
    if hit_key(event, K_F4):
        (screen_midtop, rect) = command_1280x1024(new_img, file, num_imgs, rect)
    if hit_key(event, K_F5):
        command_fullscreen(screen, new_img, file, num_imgs, rect)
    if hit_key(event, K_F6):
        gl.USING_SCROLL_MENU = 1
        (screen_midtop, rect) = command_show_res_modes(screen, new_img, file, num_imgs, rect)
        gl.USING_SCROLL_MENU = 0
    if event.type == KEYDOWN:
        mods = pygame.key.get_mods()
        if (event.key == K_DELETE and mods & KMOD_CTRL == 0) or (event.key == K_KP_PERIOD and mods & KMOD_CTRL == 0) or\
                (event.key == K_w and mods & KMOD_CTRL):
            (new_img, img, refresh_img, file, num_imgs, rect) = command_remove_img(new_img, screen, file, rect)
    if event.type == KEYDOWN:
        mods = pygame.key.get_mods()
        if (event.key == K_DELETE and mods & KMOD_CTRL) or (event.key == K_KP_PERIOD and mods & KMOD_CTRL):
            fn = gl.files[file]
            answer = get_confirmation(screen, "Delete %s? [y/n]" % basename(fn))
            if answer == "yes":
                (new_img, new_img, new_img, file, num_imgs, rect) = command_delete_img(fn, new_img, screen, file, rect)
                my_update_screen(new_img, screen, rect, file, num_imgs)
            if answer == "no":
                my_update_screen(new_img, screen, rect, file, num_imgs)
    if hit_key(event, K_s):
        (new_img, img, refresh_img, rect) = command_shuffle(new_img, img, screen, rect, file, num_imgs)
    if hit_key(event, K_u):
        (new_img, img, refresh_img, rect, file) = command_unshuffle(new_img, img, screen, rect, file, num_imgs)
    if event.type == KEYDOWN:
        mods = pygame.key.get_mods()
        if event.key == K_r and mods & KMOD_CTRL == 0:
            (new_img, img, rect) = command_rotate_right(new_img, screen, screen_midtop, file, num_imgs, rect)
    if event.type == KEYDOWN:
        mods = pygame.key.get_mods()
        if event.key == K_r and mods & KMOD_CTRL:    
            (new_img, img, rect) = command_rotate_left(new_img, screen, screen_midtop, file, num_imgs, rect)
    if event.type == KEYDOWN:
        mods = pygame.key.get_mods()
        if event.key == K_p and mods & KMOD_CTRL == 0:
            command_add_to_play_list(screen, gl.files[file])
            gl.SORT_HIT = 0
            my_update_screen(new_img, screen, rect, file, num_imgs)
    if event.type == KEYDOWN:
        mods = pygame.key.get_mods()
        if event.key == K_p and mods & KMOD_CTRL:
            (new_img, new_img, new_img, file, rect, num_imgs) = command_play_list_options(screen, file)
            gl.SORT_HIT = 0
    if event.type == KEYDOWN:
        mods = pygame.key.get_mods()
        if event.key == K_x and mods & KMOD_CTRL == 0:
            command_hide(screen, new_img, rect, file, num_imgs)
    if event.type == KEYDOWN:
        mods = pygame.key.get_mods()
        if event.key == K_x and mods & KMOD_CTRL:
            if gl.TOGGLE_STATUS_BAR:
                gl.TOGGLE_STATUS_BAR = 0
            else:
                gl.TOGGLE_STATUS_BAR = 1
            my_update_screen(new_img, screen, rect, file, num_imgs)
    if hit_key(event, K_MINUS) or hit_key(event, K_KP_MINUS):
        (new_img, img, rect) = command_zoom_out(new_img, new_img_width, new_img_height,\
        img, screen, screen_midtop, file, num_imgs, rect)
    if hit_key(event, K_EQUALS) or hit_key(event, K_KP_PLUS):
        (new_img, img, rect) = command_zoom_in(new_img, new_img_width, new_img_height, img,\
        screen, screen_midtop, gl.files, file, num_imgs, rect)
    if hit_key(event, K_DOWN):
        gl.MY_KEYDOWN = 1
    if hit_key(event, K_UP):
        gl.MY_KEYUP = 1
    if hit_key(event, K_RIGHT):
        gl.MY_KEYRIGHT = 1
    if hit_key(event, K_LEFT):
        gl.MY_KEYLEFT = 1
    if hit_key(event, K_m):
        (new_img, img, rect) = command_horiz(new_img, screen, file, num_imgs, rect)
    if hit_key(event, K_v):
        (new_img, img, rect) = command_vert(new_img, screen, file, num_imgs, rect)
    if event.type == KEYDOWN: 
        mods = pygame.key.get_mods()
        if (event.key == K_TAB and mods & KMOD_CTRL) or hit_key(event, K_SPACE) or hit_key(event, K_n):
            (new_img, img, refresh_img, file, rect) = command_next_img(new_img, img,\
            screen, screen_midtop, file, len(gl.files), rect)
    if hit_key(event, K_BACKSPACE) or hit_key(event, K_b):
        (new_img, img, refresh_img, file, rect) = command_prev_img(new_img, img,\
        screen, screen_midtop, file, len(gl.files), rect)
    if hit_key(event, K_o):
        (new_img, num_imgs) = open_url(screen, img)
        gl.URL_ERROR = False
        file = 0
        img = refresh_img = new_img
        rect = get_center(screen, new_img)
        my_update_screen(new_img, screen, rect, file, num_imgs)
        normal_cursor()
    if hit_key(event, K_ESCAPE):
        (new_img, img, rect, file) = command_refresh(refresh_img, screen, screen_midtop, gl.files, file, num_imgs)
        my_update_screen(new_img, screen, rect, file, num_imgs)
    if event.type == KEYDOWN: # ctrl+0 code
        mods = pygame.key.get_mods()
        if event.key == K_0 and mods & KMOD_CTRL:
            RESET_FIT = 0
            gl.SCALE_UP = 1
            if gl.FIT_IMAGE_VAL == "1":
                RESET_FIT = 0
            else:
                RESET_FIT = 1
                gl.FIT_IMAGE_VAL = "1"
            start = start_timer()
            wait_cursor()
            new_img = load_img(gl.files[file], screen)
            img = refresh_img = new_img
            rect = get_center(screen, new_img)
            ns = check_timer(start)
            my_update_screen(new_img, screen, rect, file, num_imgs, ns)
            if RESET_FIT == 1:
                gl.FIT_IMAGE_VAL = "0"
            normal_cursor()
    if event.type == KEYDOWN: # alt+0 code
        mods = pygame.key.get_mods()
        if ((event.key == K_0 and mods & KMOD_ALT)):
            gl.SKIP_FIT = 1
            start = start_timer()
            wait_cursor()
            new_img = load_img(gl.files[file], screen)
            img = refresh_img = new_img
            rect = get_center(screen, new_img)
            ns = check_timer(start)
            my_update_screen(new_img, screen, rect, file, num_imgs, ns)
            normal_cursor()
    if hit_key(event, K_1) or hit_key(event, K_KP1):
        if gl.FIT_IMAGE_VAL == "0":
            gl.FIT_IMAGE_VAL = "1"
            gl.SKIP_FIT = 0#
        else:
            gl.FIT_IMAGE_VAL = "0"
    if hit_key(event, K_f):
        (new_img, img, refresh_img, file, rect) = command_first_img(new_img,\
        img, screen, screen_midtop, file, len(gl.files), rect)
    if hit_key(event, K_l):
        (new_img, img, refresh_img, file, rect) = command_last_img(new_img,\
        img, screen, screen_midtop, file, len(gl.files), rect)
    if event.type == KEYDOWN:
        mods = pygame.key.get_mods()
        if (event.key == K_w and mods & KMOD_CTRL == 0) and hit_key(event, K_w):
            (new_img, img, refresh_img, file, rect) = my_slideshow(new_img, img, screen, screen_midtop, file, num_imgs, rect)
    if hit_key(event, K_e):
        gl.USING_SCROLL_MENU = 1
        (new_img, new_img, new_img, file, num_imgs, rect) = command_edit_menu(screen, file, new_img, num_imgs, rect)
        gl.USING_SCROLL_MENU = 0
    if hit_key(event, K_z):
        command_verbose_info(screen, new_img, refresh_img, rect, file, num_imgs)
    if hit_key(event, K_4):
        (file, new_img, img, refresh_img, rect) = command_four(screen, file, new_img)
        normal_cursor()
    if hit_key(event, K_t):
        gl.THUMBING = 1
        (new_img, img, refresh_img, file, rect) = command_thumbs(screen, new_img, file)
        gl.THUMBING = 0
    if hit_key(event, K_h):
        command_help(screen, new_img, file, rect, num_imgs)
    if gl.REMOTE and not gl.ALREADY_DOWNLOADED:
        if hit_key(event, K_a):
            save_remote_img(screen, file)

    return (screen, rect, new_img, img, refresh_img, file, num_imgs, screen_midtop,\
            screen_width, screen_height, new_img_width, new_img_height, last_rect)
