# image hiding code by Ryan Kulla, rkulla@gmail.com
import gl
from img_screen import my_update_screen, get_center, paint_screen
from cursor import normal_cursor
from usr_event import check_quit
import pygame.event
from pygame.display import set_caption
from input_box import ask
from show_message import show_message
from pygame.locals import K_LALT, K_RALT, K_LCTRL, K_RCTRL, K_TAB, MOUSEBUTTONDOWN, KEYDOWN
from time import ctime


def command_hide(screen, new_img, rect, file, num_imgs):
    "hide the image by making the screen blank"
    set_caption("")
    hide(screen)
    rect = get_center(screen, new_img)
    my_update_screen(new_img, screen, rect, file, num_imgs)
    set_caption("%s" % gl.TITLE)


def hide(screen):
    paint_screen(screen)
    normal_cursor()
    while 1:
        event = pygame.event.wait()
        check_quit(event)
        if event.type == KEYDOWN and event.key not in (K_LALT, K_RALT, K_LCTRL, K_RCTRL,\
        K_TAB) or event.type == MOUSEBUTTONDOWN:
            gl.SHOW_ESC_MSG = 0
            if gl.CORRECT_PASSWORD not in ("None", None):
                pw = ask(screen, "Password ")
                if pw == gl.CORRECT_PASSWORD:
                    break
                else:
                    paint_screen(screen)
                    show_message(screen, "An incorrect password was entered", "top", 14, "bold")
                    show_message(screen, "Notifying owner of tampering!", 40, 12, "bold")
                    f = open(gl.DATA_DIR + "security.log", "a")
                    f.write("Password failure: %s\n" % ctime())
                    f.close()
                    continue
            else:
                break
