# imgv screen functions by Ryan Kulla, rkulla@gmail.com
import gl
import pygame, pygame.image, pygame.surface, pygame.transform, pygame.font, pygame.version, pygame.cursors, pygame.draw
from pygame.locals import *
from status_bar import img_info


def paint_screen(screen, *rect):
    if not rect:
        screen.fill(gl.IMGV_COLOR)
        pygame.display.flip()
    else:
        screen.fill(gl.IMGV_COLOR, rect)
        pygame.display.update(rect)


def junk_rect():
    return (Rect(-1, -1, -1, -1))


def clean_screen():
    pygame.display.quit()
    pygame.font.quit()


def init_screen():
    pygame.init() # seems needed for Mac OSX
    pygame.display.init()
    pygame.font.init()
    pygame.display.set_icon(pygame.image.load(gl.DATA_DIR + "imgv-icon.png"))


def my_update_screen(new_img, screen, rect, file, num_imgs, *ns):
    screen.fill(gl.IMGV_COLOR)
    screen.blit(new_img, rect)
    pygame.display.flip()
    rect = get_center(screen, new_img)
    screen_midtop = screen.get_rect().midtop
    if not ns:
        "ns wasn't passed, store last ns value in ns"
        ns = gl.NS_GLOBAL
    else:
        "ns was passed update gl.NS_GLOBAL"
        gl.NS_GLOBAL = ns
    try:
        img_info(screen, screen_midtop, gl.files[file], file, num_imgs, new_img, ns[0])
    except:
        pass

        
def get_center(screen, new_img):
    "find out where the center of the screen is"
    screen_center = screen.get_rect().center
    rect = new_img.get_rect()
    rect.center = screen_center
    return rect

