# imgv image/movie loading code by Ryan Kulla, rkulla@gmail.com
import gl
import os
import urllib
from StringIO import StringIO
try:
    from movie_player import load_movie
except:
    print "imgv running in python2.4 doesn't support MPEG MOVIES currently!"
from screensaver import disable_screensaver, enable_screensaver
import pygame.image


def insensitive_find(haystack, needle): 
    return haystack.lower().find(needle.lower())
    

def load_img(img_file, screen):
    "load images and movies"
    if gl.PLAY_LIST_NAME != " ":
        gl.CUR_PATH = img_file
    else:
        gl.CUR_PATH = os.getcwd() + os.sep + img_file
    try:
        gl.CUR_PATH = gl.CUR_PATH[gl.CUR_PATH.rindex(os.getcwd()):] # only show path once
    except:
        pass
    try:
        if img_file[:5] == "http:": # load url
            try:
                gl.REMOTE = 1
                pic = urllib.urlopen(img_file).read()
                img = pygame.image.load(StringIO(pic))
                gl.REMOTE_FILE_SIZE = len(pic)
                gl.REMOTE_IMG_DATA = StringIO(pic)
                gl.REMOTE_IMG = img_file
                gl.ALREADY_DOWNLOADED = 0
            except:
                img = pygame.image.load(gl.ERROR_IMG).convert()
        elif insensitive_find(img_file, ".mpg") != -1 or insensitive_find(img_file, ".mpeg") != -1:
            disable_screensaver()
            if gl.THUMBING or gl.MULTI_VIEWING:
                img = pygame.image.load(gl.MOVIE_FILE).convert()
            else:
                img = load_movie(screen, img_file)
            if gl.SLIDE_SHOW_RUNNING == 0:
                enable_screensaver()
            return img
        else:
            # load normal image
            gl.REMOTE = 0
            img = pygame.image.load(img_file).convert()
    except pygame.error:
        img = pygame.image.load(gl.ERROR_IMG).convert()
        
    gl.REAL_WIDTH, gl.REAL_HEIGHT = img.get_width(), img.get_height()
    if gl.SLIDE_SHOW_RUNNING and int(gl.FIT_IMAGE_SLIDESHOW_VAL) == 1 and not gl.SKIP_FIT:
        img = fit_image(img, screen)
    if int(gl.FIT_IMAGE_VAL) == 1 and not gl.SKIP_FIT and not gl.SLIDE_SHOW_RUNNING:
        img = fit_image(img, screen)
    gl.SKIP_FIT = 0
    return img


def fit_image(img, screen):
    "fit image to the imgv window"
    rect = screen.get_rect()
    if (gl.REAL_WIDTH > rect.right or gl.REAL_HEIGHT > rect.bottom) or gl.SCALE_UP:
        # image is wider than the screen so scale it down with the same width,height ratio
         gl.SCALE_UP = 0
         if gl.REAL_WIDTH > gl.REAL_HEIGHT:
             r = float(gl.REAL_WIDTH) / float(gl.REAL_HEIGHT)
             new_width = screen.get_width()
             new_height = int(new_width / r)
             scale_val = new_width, new_height
             img = pygame.transform.scale(img, scale_val)
             gl.SHRUNK = 1
         elif gl.REAL_WIDTH < gl.REAL_HEIGHT:
             r = float(gl.REAL_HEIGHT) / float(gl.REAL_WIDTH)
             new_height = screen.get_height()
             new_width = int(new_height / r)
             scale_val = new_width, new_height
             img = pygame.transform.scale(img, scale_val)
             gl.SHRUNK = 1
         elif gl.REAL_WIDTH == gl.REAL_HEIGHT:
             r = float(gl.REAL_WIDTH) / float(gl.REAL_HEIGHT)
             new_height = screen.get_height()
             new_width = screen.get_width()
             if new_height > new_width:
                 scale_val = int(new_width / r), int(new_width / r)
             elif new_width > new_height:
                 scale_val = int(new_height / r), int(new_height / r)
             else:
                 scale_val = new_width, new_height
             img = pygame.transform.scale(img, scale_val)
         else:
             new_height = new_width = screen.get_width()
             scale_val = new_width, new_height
             img = pygame.transform.scale(img, scale_val)
    return img

