# imgv menu code by Ryan Kulla, rkulla@gmail.com
import gl
from os import getcwd, chdir
from cursor import wait_cursor, normal_cursor
from list_images import command_img_names
from thumb import command_thumbs
from verbose import command_verbose_info
from refresh import command_refresh
from help import command_help
from playlist import command_play_list_options, command_add_to_play_list
from slideshow import my_slideshow
from open_url import open_url
from hide import command_hide
from rm_img import command_remove_img
from rotate import command_horiz, command_vert, command_rotate_left, command_rotate_right
from randomizer import command_shuffle, command_unshuffle
from res import command_640x480, command_800x600, command_1024x768, command_1280x1024, command_fullscreen,\
command_show_res_modes
from edit import command_edit_menu
from zoom import command_zoom_in, command_zoom_out
from img_screen import my_update_screen, get_center, clean_screen
from four import command_four
from img_surf import command_next_img, command_prev_img, command_first_img, command_last_img
import pygame.event, pygame.mouse
from pygame.display import update
from pygame.locals import Rect, KEYDOWN, K_LALT, K_RALT, K_LCTRL, K_RCTRL, K_TAB, K_c, KEYUP, KEYDOWN, K_UP, K_DOWN, K_RIGHT, K_LEFT
from usr_event import check_quit, left_click, middle_click, right_click
from dir_nav import command_show_dirs
from handle_keyboard import handle_keyboard
from buttons import imgv_button, hover_button
from downloader import save_remote_img


def command_main_menu(refresh_img, screen, screen_midtop, file, num_imgs, rect, new_img, img, new_img_width, new_img_height):
    wait_cursor()
    menu_items = []
    i = 23
    cursor = pygame.mouse.get_pos()
    font = pygame.font.Font(gl.FONT_NAME, 11)
    font.set_bold(1)
    if gl.MENU_POS == -1:
        gl.MENU_POS = cursor[0]
    main_menu_fg(screen, font, i, menu_items)
    normal_cursor()
    last_rect = Rect(rect)
    screen_midtop = screen.get_rect().midtop
    screen_width = screen.get_width()
    screen_height = screen.get_height()
    new_img_width = new_img.get_width()
    new_img_height = new_img.get_height()
    if gl.REMOTE and not gl.ALREADY_DOWNLOADED:
        download_rect = imgv_button(screen, " Downlo(a)d Image ", None, None, "topright")
    while 1:
        event = pygame.event.poll()
        pygame.time.wait(1)
        check_quit(event)
        cursor2 = pygame.mouse.get_pos()

        if gl.REMOTE and not gl.ALREADY_DOWNLOADED:
            hover_button(download_rect, cursor2, screen, " Downlo(a)d Image ", None, None, "topright")

        if event.type == KEYDOWN:
            if event.key in (K_c, K_UP, K_DOWN, K_RIGHT, K_LEFT):
                "close the menu"
                gl.MENU_POS = -1
                my_update_screen(new_img, screen, rect, file, len(gl.files))
                normal_cursor()
                return (refresh_img, screen, screen_midtop, file, num_imgs, new_img, img, new_img_width, new_img_height, rect)
            
            (screen, rect, new_img, img, refresh_img, file, num_imgs, screen_midtop,\
            screen_width, screen_height, new_img_width, new_img_height, last_rect) =\
            handle_keyboard(event, screen, rect, new_img, img, refresh_img, file, len(gl.files),\
            screen_midtop, screen_width, screen_height, new_img_width, new_img_height, last_rect)
            break

        if left_click(event):
            wait_cursor()
            
            if gl.REMOTE and not gl.ALREADY_DOWNLOADED:
                if download_rect.collidepoint(cursor2):
                    wait_cursor()
                    save_remote_img(screen, file)
                    break
            
            for it in menu_items:
                if it[0].collidepoint(cursor2):
                    if it[1] == " Next Image ": 
                        (new_img, img, refresh_img, file, rect) = command_next_img(new_img,\
                        img, screen, screen_midtop, file, len(gl.files), rect)
                    elif it[1] == " Previous Image ":
                        (new_img, img, refresh_img, file, rect) = command_prev_img(new_img,\
                        img, screen, screen_midtop, file, len(gl.files), rect)        
                    elif it[1] == " Directory Browser ":
                        gl.USING_SCROLL_MENU = 1
                        # save current things in case the user ESCAPES out of show_dirs()
                        gl.LAST_DIR = getcwd()
                        last_files = gl.files
                        (last_new_img, last_img, last_refresh_img, last_num_imgs, last_file, last_rect) =\
                        (new_img, img, refresh_img, num_imgs, file, rect)
                        (new_img, img, refresh_img, num_imgs, file, rect) = command_show_dirs(new_img, img, screen, rect,\
                        file, num_imgs)
                        # user ESCAPED from show_dirs, reset last values
                        if gl.ESCAPED == 1:
                            (new_img, img, refresh_img, num_imgs, file, rect) =\
                            (last_new_img, last_img, last_refresh_img, last_num_imgs, last_file, last_rect)
                            chdir(gl.LAST_DIR)
                            gl.files = last_files
                            my_update_screen(new_img, screen, rect, file, num_imgs)
                        else:
                            gl.REFRESH_IMG_COUNT = 0
                        gl.ESCAPED = 0
                        gl.USING_SCROLL_MENU = 0
                    elif it[1] == " Image Browser ":
                        (new_img, img, refresh_img, file, rect) = command_img_names(screen, new_img, img, file,\
                        num_imgs, rect)
                    elif it[1] == " Thumbnails ":
                        gl.THUMBING = 1
                        (new_img, img, refresh_img, file, rect) = command_thumbs(screen, new_img, file)
                        gl.THUMBING = 0
                    elif it[1] == " Image Details ":
                        command_verbose_info(screen, new_img, refresh_img, rect, file, num_imgs)
                    elif it[1] == " Zoom Out ":
                        (new_img, img, rect) = command_zoom_out(new_img, new_img_width,\
                        new_img_height, img, screen, screen_midtop, file, num_imgs, rect)
                    elif it[1] == " Zoom In ":
                        (new_img, img, rect) = command_zoom_in(new_img, new_img_width,\
                        new_img_height, img, screen, screen_midtop, gl.files, file, num_imgs, rect)
                    elif it[1] == " Close Image ":
                        (new_img, img, refresh_img, file, num_imgs, rect) = command_remove_img(new_img, screen, file, rect)
                    elif it[1] == " Rotate CW ":
                        (new_img, img, rect) = command_rotate_right(new_img, screen, screen_midtop, file, num_imgs, rect)
                    elif it[1] == " Rotate CCW ":
                        (new_img, img, rect) = command_rotate_left(new_img, screen, screen_midtop, file, num_imgs, rect)
                    elif it[1] == " Four At A Time ":
                        (file, new_img, img, refresh_img, rect) = command_four(screen, file, new_img)
                        normal_cursor()
                    elif it[1] == " Resize Window ":
                        gl.USING_SCROLL_MENU = 1
                        (screen_midtop, rect) = command_show_res_modes(screen, new_img, file, num_imgs, rect)
                        gl.USING_SCROLL_MENU = 0
                    elif it[1] == " Refresh ":
                        (new_img, img, rect, file) = command_refresh(refresh_img, screen, screen_midtop, gl.files, file,\
                        num_imgs)
                    elif it[1] == " First Image ":
                        (new_img, img, refresh_img, file, rect) = command_first_img(new_img,\
                        img, screen, screen_midtop, file, len(gl.files), rect)
                    elif it[1] == " Last Image ":
                        (new_img, img, refresh_img, file, rect) = command_last_img(new_img,\
                        img, screen, screen_midtop, file, len(gl.files), rect)
                    elif it[1] == " Shuffle ":
                        (new_img, img, refresh_img, rect) = command_shuffle(new_img, img, screen, rect, file, num_imgs)
                    elif it[1] == " Unshuffle ":
                        (new_img, img, refresh_img, rect, file) = command_unshuffle(new_img, img, screen, rect, file, num_imgs)
                    elif it[1] == " Flip Horizontal ":
                        (new_img, img, rect) = command_horiz(new_img, screen, file, num_imgs, rect)
                    elif it[1] == " Flip Vertical ":
                        (new_img, img, rect) = command_vert(new_img, screen, file, num_imgs, rect)
                    elif it[1] == " Slide Show ":
                        (new_img, img, refresh_img, file, rect) = my_slideshow(new_img, img, screen, screen_midtop,\
                        file, num_imgs, rect)
                    elif it[1] == " Playlist Options ":
                        (new_img, new_img, new_img, file, rect, num_imgs) = command_play_list_options(screen, file)
                        gl.SORT_HIT = 0
                    elif it[1] == " Add To Playlist ":
                        command_add_to_play_list(screen, gl.files[file])
                        gl.SORT_HIT = 0
                    elif it[1] == " Edit ":
                        gl.USING_SCROLL_MENU = 1
                        (new_img, new_img, new_img, file, num_imgs, rect) = command_edit_menu(screen, file, new_img,\
                        num_imgs, rect)
                        gl.USING_SCROLL_MENU = 0
                    elif it[1] == " Hide Image ":
                        command_hide(screen, new_img, rect, file, num_imgs)
                    elif it[1] == " Extract From Web ":
                        (new_img, num_imgs) = open_url(screen, img)
                        gl.URL_ERROR = False
                        file = 0
                        img = refresh_img = new_img
                        rect = get_center(screen, new_img)
                        my_update_screen(new_img, screen, rect, file, len(gl.files))
                        normal_cursor()
                    elif it[1] == " Help ":
                        command_help(screen, new_img, file, rect, num_imgs)
                    elif it[1] == " Font Color ":
                        if gl.MENU_COLOR_ITEM >= (len(gl.MENU_ADJUST) - 1):
                            gl.MENU_COLOR_ITEM = 0
                        else:
                            gl.MENU_COLOR_ITEM = gl.MENU_COLOR_ITEM + 1
                        gl.MENU_COLOR = gl.MENU_ADJUST[gl.MENU_COLOR_ITEM]
                        gl.SHOW_MESSAGE_COLOR = gl.MENU_ADJUST[gl.MENU_COLOR_ITEM]
                        if gl.FONT_BG_NEED_CHANGE:
                            if gl.MENU_COLOR == gl.WHITE:
                                gl.FONT_BG = gl.BLACK
                            else:
                                gl.FONT_BG = gl.WHITE
                        my_update_screen(new_img, screen, rect, file, len(gl.files))
                        (refresh_img, screen, screen_midtop, file, num_imgs, new_img, img, new_img_width, new_img_height,\
                        rect) = command_main_menu(refresh_img, screen, screen_midtop, file, num_imgs, rect, new_img, img,\
                        new_img_width, new_img_height)
                        return (refresh_img, screen, screen_midtop, file, num_imgs, new_img, img, new_img_width, new_img_height, rect)
                    elif it[1] == " Close Menu ":
                        gl.MENU_POS = -1
                        my_update_screen(new_img, screen, rect, file, len(gl.files))
                        normal_cursor()
                        return (refresh_img, screen, screen_midtop, file, num_imgs, new_img, img, new_img_width, new_img_height, rect)
                    elif it[1] == " Exit ":
                        clean_screen()
                        raise SystemExit
                    elif it[1] == " Status Bars ":
                        if gl.TOGGLE_STATUS_BAR:
                            gl.TOGGLE_STATUS_BAR = 0
                        else:
                            gl.TOGGLE_STATUS_BAR = 1
                    elif it[1] == " Transparent ":
                        if gl.TOGGLE_TRANSPARENT:
                            gl.TOGGLE_TRANSPARENT = 0
                        else:
                            gl.TOGGLE_TRANSPARENT = 1
                
            break
        if event.type == KEYDOWN and event.key not in (K_LALT, K_RALT, K_LCTRL, K_RCTRL, K_TAB):
            my_update_screen(new_img, screen, rect, file, len(gl.files))
            return (refresh_img, screen, screen_midtop, file, num_imgs, new_img, img, new_img_width, new_img_height, rect)
        if middle_click(event):
            "close the menu upon middle click"
            gl.MENU_POS = -1
            my_update_screen(new_img, screen, rect, file, len(gl.files))
            normal_cursor()
            return (refresh_img, screen, screen_midtop, file, num_imgs, new_img, img, new_img_width, new_img_height, rect)
        if right_click(event):
            wait_cursor()
            gl.MENU_POS = -1
            my_update_screen(new_img, screen, rect, file, len(gl.files))
            (refresh_img, screen, screen_midtop, file, num_imgs, new_img, img, new_img_width, new_img_height, rect) =\
            command_main_menu(refresh_img, screen, screen_midtop, file, num_imgs, rect, new_img, img, new_img_width, new_img_height)
            return (refresh_img, screen, screen_midtop, file, num_imgs, new_img, img, new_img_width, new_img_height, rect)
    if gl.KEEP_MENU_OPEN == "1":
        # this code purposely closes the main menu by breaking the recursion to free up RAM memory
        gl.COUNT_CLICKS += 1
        if gl.COUNT_CLICKS == 1: # free up ram every click
            my_update_screen(new_img, screen, rect, file, len(gl.files))
            return (refresh_img, screen, screen_midtop, file, num_imgs, new_img, img, new_img_width, new_img_height, rect)
        my_update_screen(new_img, screen, rect, file, len(gl.files))
        (refresh_img, screen, screen_midtop, file, num_imgs, new_img, img, new_img_width, new_img_height, rect) =\
        command_main_menu(refresh_img, screen, screen_midtop, file, num_imgs, rect, new_img, img, new_img_width, new_img_height)
    normal_cursor()
    return (refresh_img, screen, screen_midtop, file, num_imgs, new_img, img, new_img_width, new_img_height, rect)


def main_menu_fg(screen, font, i, menu_items):
    for item in gl.MENU_ITEMS:
        if screen.get_size()[1] < 530 and item == "": # don't show divider on small screens
            continue
        if gl.TOGGLE_TRANSPARENT and item != "": # item != "" allows there to be a space-divider in the menu
            ren = font.render(item, 1, gl.MENU_COLOR, gl.FONT_BG)
        else:
            ren = font.render(item, 1, gl.MENU_COLOR) # transparent
        ren_rect = ren.get_rect()
        ren_rect[0] = gl.MENU_POS
        ren_rect[1] = i
        if len(menu_items) <= gl.MENU_ITEMS: # so it doesn't keep appending
            menu_items.append((ren_rect, item))
        screen.blit(ren, (gl.MENU_POS, i))
        i = i + 14 # space between each menu item in menu
        update(ren_rect)
