# image panning code by Ryan Kulla, rkulla@gmail.com
import gl
from status_bar import img_info
from cursor import wait_cursor, normal_cursor
from pygame.display import update


def command_down(rect, last_rect, new_img, screen, file, num_imgs, screen_midtop):
    "scroll image to see more of the top"
    wait_cursor()
    if (rect.top + gl.MOVE) < 0:
        rect.top = rect.top + gl.MOVE
        screen.blit(new_img, rect)
        update(rect.union(last_rect))
        img_info(screen, screen_midtop, gl.files[file], file, num_imgs, new_img, gl.NS_GLOBAL[0])
    normal_cursor()
    return rect


def command_up(rect, last_rect, new_img, screen, file, num_imgs, screen_midtop, screen_height):
    "scroll image to see more of the bottom"
    wait_cursor()
    if (rect.bottom - gl.MOVE) > screen_height:
        rect.bottom = rect.bottom - gl.MOVE
        screen.blit(new_img, rect)
        update(rect.union(last_rect))
        img_info(screen, screen_midtop, gl.files[file], file, num_imgs, new_img, gl.NS_GLOBAL[0])
    normal_cursor()
    return rect


def command_right(rect, last_rect, new_img, screen, file, num_imgs, screen_midtop):
    "scroll image to see more of its left side"
    wait_cursor()
    if (rect.left + gl.MOVE) < 0:
        rect.left = rect.left + gl.MOVE
        screen.blit(new_img, rect)
        update(rect.union(last_rect))
        img_info(screen, screen_midtop, gl.files[file], file, num_imgs, new_img, gl.NS_GLOBAL[0])
    normal_cursor()
    return rect 


def command_left(rect, last_rect, new_img, screen, file, num_imgs, screen_midtop, screen_width):
    "scroll image to see more of its right side"
    wait_cursor()
    if (rect.right - gl.MOVE) > screen_width:
        rect.right = rect.right - gl.MOVE
        screen.blit(new_img, rect)
        update(rect.union(last_rect))
        img_info(screen, screen_midtop, gl.files[file], file, num_imgs, new_img, gl.NS_GLOBAL[0])
    normal_cursor()
    return rect 
