# image rotate/flip code by Ryan Kulla, rkulla@gmail.com
import gl
from load_timers import start_timer, check_timer
from cursor import wait_cursor, normal_cursor
from img_screen import get_center, my_update_screen
import pygame.transform


def command_rotate_left(new_img, screen, screen_midtop, file, num_imgs, rect):
    "rotate counter clockwise"
    wait_cursor()
    start = start_timer()
    new_img = pygame.transform.rotozoom(new_img, 90, 1)
    rect = get_center(screen, new_img)
    ns = check_timer(start)
    my_update_screen(new_img, screen, rect, file, num_imgs, ns)
    normal_cursor()
    return (new_img, new_img, rect)


def command_rotate_right(new_img, screen, screen_midtop, file, num_imgs, rect):
    "rotate clockwise"
    wait_cursor()
    start = start_timer()
    new_img = pygame.transform.rotozoom(new_img, -90, 1)
    rect = get_center(screen, new_img)
    ns = check_timer(start)
    my_update_screen(new_img, screen, rect, file, num_imgs, ns)
    normal_cursor()
    return (new_img, new_img, rect)


def command_horiz(new_img, screen, file, num_imgs, rect):
    "flip horizontally (mirror)"
    wait_cursor()
    start = start_timer()
    new_img = pygame.transform.flip(new_img, 90, 0)
    ns = check_timer(start)
    my_update_screen(new_img, screen, rect, file, num_imgs, ns)
    normal_cursor()
    return (new_img, new_img, rect)


def command_vert(new_img, screen, file, num_imgs, rect):
    "flip vertically"
    wait_cursor()
    start = start_timer()
    new_img = pygame.transform.flip(new_img, 90, 90)
    ns = check_timer(start)
    my_update_screen(new_img, screen, rect, file, num_imgs, ns)
    normal_cursor()
    return (new_img, new_img, rect)
