# imgv message rendering code by Ryan Kulla, rkulla@gmail.com
import gl
import pygame.font
from pygame.display import update
from types import StringType


def show_message(screen, msg, down_value, font_size, *font_ops):
    "write a message centered anywhere on the screen"
    font = pygame.font.Font(gl.FONT_NAME, font_size)

    if font_ops:
        font_options(font_ops, font)
        
    if gl.TOGGLE_TRANSPARENT:
        ren = font.render(msg, 1, gl.SHOW_MESSAGE_COLOR, gl.FONT_BG)
    else: # use transparent font background
        ren = font.render(msg, 1, gl.SHOW_MESSAGE_COLOR)
    if gl.USING_SCROLL_MENU: # to let the blank_fx() work right
        ren = font.render(msg, 1, gl.SHOW_MESSAGE_COLOR, gl.FONT_BG)
    ren_rect = ren.get_rect()
    if down_value == "bottom":
        ren_rect.midbottom = screen.get_rect().midbottom
    elif down_value == "top":
        ren_rect.midtop = screen.get_rect().midtop
    elif isinstance(down_value, tuple):
        ren_rect = ren.get_rect()
        ren_rect[0] = down_value[0]
        ren_rect[1] = down_value[1]
    else:
        ren_rect.centerx = screen.get_rect().centerx
        ren_rect[1] = down_value
    screen.blit(ren, ren_rect)
    update(ren_rect)
    return (ren_rect)


def font_options(font_ops, font):
    # lets you have bold and/or underline and/or italic fonts
    if type(font_ops[0]) is StringType:
        if font_ops[0] == "bold":
            font.set_bold(1)
        if font_ops[0] == "underline":
            font.set_underline(1)
        if font_ops[0] == "italic":
            font.set_italic(1)
    else:
        if font_ops[0][0] == "bold":
            font.set_bold(1)
        if font_ops[0][0] == "underline":
            font.set_underline(1)
        if font_ops[0][0] == "italic":
            font.set_italic(1)

    if len(font_ops[0]) > 1:
        if font_ops[0][1] == "underline":
            font.set_underline(1)
        if font_ops[0][1] == "bold":
            font.set_bold(1)
        if font_ops[0][1] == "italic":
            font.set_italic(1)
            
        if len(font_ops[0]) > 2:
            if font_ops[0][2] == "underline":
                font.set_underline(1)
            if font_ops[0][2] == "bold":
                font.set_bold(1)
            if font_ops[0][2] == "italic":
                font.set_italic(1)
