# image zooming code by Ryan Kulla, rkulla@gmail.com
import gl
from cursor import wait_cursor, normal_cursor
from img_screen import get_center, my_update_screen
from load_timers import start_timer, check_timer
import pygame.transform


def command_zoom_out(new_img, new_img_width, new_img_height, img, screen, screen_midtop, file, num_imgs, rect):
    wait_cursor()
    new_img_width = new_img.get_width()
    new_img_height = new_img.get_height()
    start = start_timer()
    if new_img_width >= gl.MIN_WIDTH and new_img_height >= gl.MIN_HEIGHT:
        new_img = pygame.transform.scale(img, (new_img_width / 1.2, new_img_height / 1.2))
        rect = get_center(screen, new_img)
        ns = check_timer(start)
        my_update_screen(new_img, screen, rect, file, num_imgs, ns)
    normal_cursor()
    return (new_img, img, rect)


def command_zoom_in(new_img, new_img_width, new_img_height, img, screen, screen_midtop, files, file, num_imgs, rect):
    wait_cursor()
    new_img_width = new_img.get_width()
    new_img_height = new_img.get_height()
    start = start_timer()
    if new_img_width < gl.MAX_WIDTH and new_img_height < gl.MAX_HEIGHT:
        new_img = pygame.transform.scale(img, (new_img_width * 1.2, new_img_height * 1.2))
        rect = get_center(screen, new_img)
        ns = check_timer(start)
        my_update_screen(new_img, screen, rect, file, num_imgs, ns)
    normal_cursor()
    return (new_img, img, rect)
